{"version":3,"file":"entrypoint0.js","names":["value: UrlParamValue | UrlParam","params: Record<string, UrlParam>","params: GetLinkParams","url: string","base?: string","path: string","normalized: string[]","value: string","init?: string | Record<string, string | string[]>","key: string","pairs: string[]","queryParameters: Record<string, any>","pathParameters: Record<string, any>","ExceptionControllerGetLinks","payload: ExceptionRenderOptional","LinkGenerator","Layout0","Layout1"],"sources":["../../../home/runner/work/mountaineer-exceptions/mountaineer-exceptions/mountaineer_exceptions/views/_server/api.ts","../../../home/runner/work/mountaineer-exceptions/mountaineer-exceptions/mountaineer_exceptions/views/core/exception/_server/links.ts","../../../home/runner/work/mountaineer-exceptions/mountaineer-exceptions/mountaineer_exceptions/views/_server/links.ts","../../../home/runner/work/mountaineer-exceptions/mountaineer-exceptions/mountaineer_exceptions/views/core/exception/_server/useServer.ts","../../../home/runner/work/mountaineer-exceptions/mountaineer-exceptions/mountaineer_exceptions/views/core/exception/page.tsx","../../.tmp5zypby/entrypoint0.jsx"],"sourcesContent":["/*\n * Common Typescript API for client<->server communication, automatically copied\n * to each component project during schema generation.\n */\n\n// Type for values that can be converted to strings for URL parameters\nexport type UrlParamValue = string | number | boolean | Date | null | undefined;\nexport type UrlParamArray = Array<string | number | boolean | Date>;\nexport type UrlParam = UrlParamValue | UrlParamArray;\n\nexport class FetchErrorBase<T> extends Error {\n  statusCode: number;\n  body: T;\n\n  constructor(statusCode: number, body: T) {\n    const bodyString = typeof body === \"string\" ? body : JSON.stringify(body);\n    super(`Error ${statusCode}: ${bodyString}`);\n\n    this.statusCode = statusCode;\n    this.body = body;\n  }\n}\n\ninterface FetchParams {\n  method: string;\n  url: string;\n  path?: Record<string, UrlParamValue>;\n  query?: Record<string, UrlParam>;\n  headers?: Record<string, UrlParam>;\n  errors?: Record<\n    number,\n    new (statusCode: number, body: any) => FetchErrorBase<any>\n  >;\n  body?: Record<string, any>;\n  mediaType?: string;\n  outputFormat?: \"json\" | \"text\" | \"raw\";\n  eventStreamResponse?: boolean;\n  signal?: AbortSignal;\n}\n\nexport const convertToUrlString = (\n  value: UrlParamValue | UrlParam,\n): string | undefined => {\n  /*\n   * Helper function to convert various types to string for URL parameters\n   */\n  if (value === null || value === undefined) {\n    return undefined;\n  }\n\n  if (value instanceof Date) {\n    return value.toISOString();\n  }\n\n  return String(value);\n};\n\nexport const processUrlParams = (\n  params: Record<string, UrlParam>,\n): ServerURLSearchParams => {\n  /*\n   * Helper function to process URL parameters\n   */\n  const searchParams = new ServerURLSearchParams();\n\n  for (const [key, value] of Object.entries(params)) {\n    if (value === null || value === undefined) {\n      continue;\n    }\n\n    if (Array.isArray(value)) {\n      // Handle array values\n      value.forEach((item) => {\n        const strValue = convertToUrlString(item);\n        if (strValue !== undefined) {\n          searchParams.append(key, strValue);\n        }\n      });\n    } else {\n      // Handle single values\n      const strValue = convertToUrlString(value);\n      if (strValue !== undefined) {\n        searchParams.append(key, strValue);\n      }\n    }\n  }\n\n  return searchParams;\n};\n\nexport const handleOutputFormat = async (\n  response: Response,\n  format?: \"text\" | \"raw\" | \"json\",\n) => {\n  if (format === \"text\") {\n    return await response.text();\n  } else if (format == \"raw\") {\n    return response;\n  } else {\n    // Assume JSON if not specified\n    return await response.json();\n  }\n};\n\nexport const __request = async (params: FetchParams) => {\n  /*\n   * Core function that handles all the logic for issuing actions to the server. Interally\n   * this mostly wraps the fetch API, but adds some additional functionality to:\n   * - Automatically handle JSON serialization and deserialization\n   * - Handle dynamic URL parameter conventions\n   * - Parse error responses and serialize them into exceptions\n   */\n  let contentType: string | undefined = params.mediaType || \"application/json\";\n  let payloadBody: string | FormData | undefined = undefined;\n\n  if (params.body) {\n    if (contentType == \"application/json\") {\n      payloadBody = JSON.stringify(params.body);\n    } else if (contentType == \"multipart/form-data\") {\n      payloadBody = new FormData();\n      for (const [key, value] of Object.entries(params.body)) {\n        payloadBody.append(key, value);\n      }\n\n      // Manually specifying multipart/form-data alongside the FormData requires\n      // us to also send the boundary. We'd rather let the browser handle this.\n      contentType = undefined;\n    }\n  }\n\n  // Process URL and path parameters\n  let url = new ServerURL(params.url);\n\n  // Fill path parameters\n  for (const [key, value] of Object.entries(params.path || {})) {\n    const strValue = convertToUrlString(value);\n    if (strValue === undefined) {\n      throw new Error(`Missing required path parameter ${key}`);\n    }\n    url.pathname = decodeURIComponent(url.pathname).replace(\n      `{${key}}`,\n      strValue,\n    );\n  }\n\n  // Process and append query parameters\n  if (params.query) {\n    const searchParams = processUrlParams(params.query);\n    url.search = searchParams.toString();\n  }\n\n  // Fill headers\n  const headers: Record<string, string> = {\n    ...(contentType && { \"Content-Type\": contentType }),\n  };\n\n  if (params.headers) {\n    for (const [key, value] of Object.entries(params.headers)) {\n      const strValue = convertToUrlString(value);\n      if (strValue !== undefined) {\n        headers[key] = strValue;\n      }\n    }\n  }\n\n  try {\n    const response = await fetch(url.toString(), {\n      method: params.method,\n      headers,\n      body: payloadBody,\n      signal: params.signal,\n    });\n\n    if (response.status >= 200 && response.status < 300) {\n      if (params.eventStreamResponse) {\n        if (!response.body) {\n          throw new Error(\"Response body is undefined\");\n        }\n        return handleStreamOutputFormat(response.body, params.outputFormat);\n      }\n      return await handleOutputFormat(response, params.outputFormat);\n    } else {\n      console.log(\"ERROR\", response.status)\n\n      // Try to handle according to our error map. By convention if we have an error\n      // that's specified explicitly as an APIException type, the response payload\n      // will be in JSON format.\n      if (params.errors && params.errors[response.status]) {\n        const errorClass = params.errors[response.status];\n        throw new errorClass(\n          response.status,\n          await handleOutputFormat(response, \"json\"),\n        );\n      }\n\n      // It's rare that we don't have typehinted context to a more specific exception, but it\n      // can happen. Handle with a generic error.\n      throw new FetchErrorBase<string>(\n        response.status,\n        await handleOutputFormat(response, \"text\"),\n      );\n    }\n  } catch (e) {\n    // If we've caught the FetchErrorBase, rethrow it\n    if (e instanceof FetchErrorBase) {\n      throw e;\n    }\n\n    // Otherwise we have an unhandled error, rethrow as a generic error\n    const errorText = e instanceof Error ? e.toString() : \"Unknown error\";\n    const errorStack = e instanceof Error ? e.stack : undefined;\n\n    const error = new FetchErrorBase<any>(-1, errorText);\n    error.stack = errorStack;\n    throw error;\n  }\n};\n\nconst handleStreamOutputFormat = async (\n  stream: ReadableStream<Uint8Array>,\n  format?: string,\n) => {\n  /*\n   * Unlike the typical implementation of EventSource (which only supports basic\n   * GET and no custom headers), we'd rather piggyback on fetch() and iteratively parse\n   * the response payload. We should implement reconnection logic in the future to\n   * achieve parity with EventSource.\n   */\n  const reader = stream.getReader();\n  const decoder = new TextDecoder();\n  let buffer = \"\";\n\n  return (async function* () {\n    while (true) {\n      const { done, value } = await reader.read();\n      if (done) {\n        // If there's any residual data in the buffer when the stream ends,\n        // yield it as the last piece of data.\n        if (buffer.length > 0) {\n          yield format === \"text\" ? buffer : JSON.parse(buffer);\n        }\n        break;\n      }\n\n      // Decode the current chunk and add it to the buffer.\n      const textChunk = decoder.decode(value, { stream: true });\n      buffer += textChunk;\n\n      // Check for new lines in the buffer, and yield each line as a separate piece of data.\n      let newLineIndex: number;\n      while ((newLineIndex = buffer.indexOf(\"\\n\")) !== -1) {\n        // Extract the line including the new line character, and adjust the buffer.\n        let line = buffer.slice(0, newLineIndex + 1);\n        buffer = buffer.slice(newLineIndex + 1);\n\n        // If the line starts with \"data:\", strip it and trim the line.\n        if (line.startsWith(\"data:\")) {\n          line = line.replace(/^data:/, \"\").trim();\n        }\n\n        // Yield the line in the requested format.\n        yield format === \"text\" ? line : JSON.parse(line);\n      }\n    }\n  })();\n};\n\ntype ApiFunctionReturnType<S, P> = {\n  sideeffect: S;\n  passthrough?: P;\n};\n\nexport function applySideEffect<\n  ARG extends any[],\n  S,\n  P,\n  RE extends ApiFunctionReturnType<S, P>,\n>(\n  apiFunction: (...args: ARG) => Promise<RE>,\n  setControllerState: (payload: S) => void,\n): (...args: ARG) => Promise<RE> {\n  /*\n   * Executes an API server function, triggering any appropriate exceptions.\n   * If the fetch succeeds, the sideeffect is applied to the controller state.\n   */\n  return async (...args: ARG) => {\n    const result = await apiFunction(...args);\n    setControllerState(result.sideeffect);\n    return result;\n  };\n}\n\ninterface GetLinkParams {\n  rawUrl: string;\n  queryParameters: Record<string, UrlParam>;\n  pathParameters: Record<string, UrlParamValue>;\n}\n\nexport const __getLink = (params: GetLinkParams) => {\n  // Format the URL using the standard URL API\n  const url = new ServerURL(params.rawUrl);\n\n  // Fill path parameters\n  for (const [key, value] of Object.entries(params.pathParameters)) {\n    const strValue = convertToUrlString(value);\n    if (strValue === undefined) {\n      throw new Error(`Missing required path parameter ${key}`);\n    }\n    url.pathname = decodeURIComponent(url.pathname).replace(\n      `{${key}}`,\n      strValue,\n    );\n  }\n\n  // Process query parameters\n  if (params.queryParameters) {\n    const searchParams = processUrlParams(params.queryParameters);\n    url.search = searchParams.toString();\n  }\n\n  return decodeURIComponent(url.toString());\n};\n\nexport class ServerURL {\n  private _protocol: string = \"\";\n  private _host: string = \"\";\n  private _pathname: string = \"\";\n  private _search: string = \"\";\n\n  constructor(url: string, base?: string) {\n    // Handle absolute URLs (those starting with a protocol)\n    if (url.match(/^[a-zA-Z]+:\\/\\//)) {\n      const [protocol, rest] = url.split(\"://\");\n      const [host, ...pathParts] = rest.split(\"/\");\n      this._protocol = protocol;\n      this._host = host;\n      this._pathname = \"/\" + pathParts.join(\"/\");\n      return;\n    }\n\n    // Split URL into pathname and search parts\n    const [pathname, search] = url.split(\"?\");\n\n    // Handle base path\n    if (base && !pathname.startsWith(\"/\")) {\n      const baseDir = base.endsWith(\"/\") ? base : base + \"/\";\n      this._pathname = this.normalizePath(baseDir + pathname);\n    } else {\n      this._pathname = this.normalizePath(pathname);\n    }\n\n    this._search = search ? `?${search}` : \"\";\n  }\n\n  private normalizePath(path: string): string {\n    // Ensure path starts with /\n    if (!path.startsWith(\"/\")) {\n      path = \"/\" + path;\n    }\n\n    // Split into segments and normalize\n    const segments = path.split(\"/\");\n    const normalized: string[] = [];\n\n    for (const segment of segments) {\n      if (!segment || segment === \".\") continue;\n      if (segment === \"..\") {\n        normalized.pop();\n      } else {\n        normalized.push(segment);\n      }\n    }\n\n    return \"/\" + normalized.join(\"/\");\n  }\n\n  get pathname(): string {\n    return this._pathname;\n  }\n\n  set pathname(value: string) {\n    this._pathname = this.normalizePath(value);\n  }\n\n  get search(): string {\n    return this._search;\n  }\n\n  set search(value: string) {\n    this._search = value ? (value.startsWith(\"?\") ? value : `?${value}`) : \"\";\n  }\n\n  toString(): string {\n    if (this._protocol && this._host) {\n      return `${this._protocol}://${this._host}${this._pathname}${this._search}`;\n    }\n    return `${this._pathname}${this._search}`;\n  }\n}\n\nexport class ServerURLSearchParams {\n  private params: Map<string, string[]>;\n\n  constructor(init?: string | Record<string, string | string[]>) {\n    this.params = new Map();\n\n    if (!init) return;\n\n    if (typeof init === \"string\") {\n      // Handle string initialization\n      const query = init.startsWith(\"?\") ? init.slice(1) : init;\n      for (const pair of query.split(\"&\")) {\n        if (!pair) continue;\n        const [key, value] = pair.split(\"=\").map(decodeURIComponent);\n        this.append(key, value ?? \"\");\n      }\n    } else {\n      // Handle object initialization\n      for (const [key, value] of Object.entries(init)) {\n        if (Array.isArray(value)) {\n          for (const v of value) {\n            this.append(key, v);\n          }\n        } else {\n          this.append(key, value);\n        }\n      }\n    }\n  }\n\n  append(key: string, value: string): void {\n    const values = this.params.get(key) || [];\n    values.push(String(value));\n    this.params.set(key, values);\n  }\n\n  toString(): string {\n    const pairs: string[] = [];\n    for (const [key, values] of this.params) {\n      for (const value of values) {\n        pairs.push(`${encodeURIComponent(key)}=${encodeURIComponent(value)}`);\n      }\n    }\n    return pairs.join(\"&\");\n  }\n}\n","/*\n * This file was generated by Mountaineer v0.1.0. Do not edit it manually.\n */\n\nimport { __getLink } from '../../../_server/api';\n\n\n\nexport const getLink = ({\n  exception,\n  stack\n}: {\n  exception: string,\n  stack: string\n}) => {\n  const url = `/_exception`;\n\n  const queryParameters: Record<string, any> = {\n    exception,\n    stack\n  };\n  const pathParameters: Record<string, any> = {\n\n  };\n\n  return __getLink({\n    rawUrl: url,\n    queryParameters,\n    pathParameters\n  });\n};","/*\n * This file was generated by Mountaineer v0.1.0. Do not edit it manually.\n */\n\nimport { getLink as ExceptionControllerGetLinks } from '../core/exception/_server/links';\n\nconst linkGenerator = {\n  exceptionController: ExceptionControllerGetLinks\n};\n\nexport default linkGenerator;","/*\n * This file was generated by Mountaineer v0.1.0. Do not edit it manually.\n */\n\nimport React, { useState } from 'react';\nimport { applySideEffect } from '../../../_server/api';\nimport LinkGenerator from '../../../_server/links';\n\nimport { ExceptionRender, ExceptionController } from '../../../_server/controllers';\n\ndeclare global {\n  var SERVER_DATA: any;\n}\n\nexport interface ServerState extends ExceptionRender, ExceptionController {\n  linkGenerator: typeof LinkGenerator;\n}\n\nexport type ExceptionRenderOptional = Partial<ExceptionRender>;\n\nexport const useServer = () : ServerState => {\n  const [serverState, setServerState] = useState(SERVER_DATA['ExceptionController'] as ExceptionRender);\n\n  const setControllerState = (payload: ExceptionRenderOptional) => {\n    setServerState((state) => ({\n      ...state,\n      ...payload,\n    }));\n  };\n\n  return {\n  ...serverState,\n  'linkGenerator': LinkGenerator\n}\n};","import { useState } from \"react\";\nimport { useServer } from \"./_server/useServer\";\n\nconst Page = () => {\n  const serverState = useServer();\n  const [showFrame, setShowFrame] = useState<string | null>(null);\n  const timestamp = new Date().toISOString();\n\n  return (\n    <>\n      <style>{serverState.formatting_style}</style>\n      <style>{`\n        .highlight pre {\n          line-height: inherit !important;\n          }\n        `}</style>\n      <div className=\"md:mx-20 space-y-6 rounded-lg p-8\">\n        <div className=\"space-y-2\">\n          <div className=\"text-sm text-zinc-500 font-mono\">\n            Timestamp: {timestamp}\n            <br />\n            Environment: {process.env.NODE_ENV}\n          </div>\n          <h1 className=\"font-mono text-xl font-semibold text-zinc-800 whitespace-pre-wrap\">\n            {serverState.exception}\n          </h1>\n        </div>\n        <div className=\"space-y-4\">\n          <div className=\"flex items-center space-x-1 text-red-600 font-semibold whitespace-pre-wrap\">\n            <span>{serverState.parsed_exception.exc_type}:</span>\n            <span>{serverState.parsed_exception.exc_value}</span>\n          </div>\n\n          {serverState.parsed_exception.frames.map((frame, index) => (\n            <div key={frame.id}>\n              <div className=\"border rounded-lg overflow-hidden bg-white\">\n                {/* File header */}\n                <div className=\"bg-gray-100 px-4 py-2 border-b flex justify-between items-center\">\n                  <div className=\"font-mono text-sm text-gray-700\">\n                    {frame.file_name}:{frame.line_number}\n                  </div>\n                  <button\n                  type=\"button\"\n                    onClick={() => {\n                      if (showFrame !== frame.id) {\n                        setShowFrame(frame.id);\n                      } else {\n                        setShowFrame(null);\n                      }\n                    }}\n                    className=\"px-3 py-1 bg-blue-500 hover:bg-blue-600 transition-colors text-white rounded text-sm\"\n                  >\n                    {frame.function_name}\n                  </button>\n                </div>\n\n                {/* Code section */}\n                <div className=\"flex\">\n                  {/* Line numbers */}\n                  <div className=\"py-4 px-3 text-right font-mono text-sm bg-gray-50 text-gray-500 select-none border-r\">\n                    {Array.from(\n                      {\n                        length: frame.end_line_number - frame.start_line_number,\n                      },\n                      (_, i) => (\n                        <div\n                          // biome-ignore lint/suspicious/noArrayIndexKey: Required for server HTML rendering\n                          key={i}\n                          className={`leading-6 ${\n                            frame.start_line_number + i === frame.line_number\n                              ? \"bg-red-100 text-red-600 font-semibold px-2 -mx-2\"\n                              : \"\"\n                          }`}\n                        >\n                          {frame.start_line_number + i}\n                        </div>\n                      ),\n                    )}\n                  </div>\n\n                  {/* Code content */}\n                  <div\n                    className=\"flex-1 p-4 overflow-x-auto font-mono text-sm bg-gray-800 !leading-6\"\n                    // biome-ignore lint/security/noDangerouslySetInnerHtml: Required for server HTML rendering\n                    dangerouslySetInnerHTML={{ __html: frame.code_context }}\n                  />\n                </div>\n              </div>\n\n              {/* Local variables */}\n              {showFrame === frame.id && (\n                <div className=\"mt-4 rounded-lg overflow-hidden border border-gray-200 shadow-sm mb-12\">\n                  <div className=\"bg-gray-100 p-4 font-mono text-sm font-bold text-gray-700 border-b flex items-center\">\n                    <div className=\"grow\">Local Variables</div>\n                    <button\n                      type=\"button\"\n                      onClick={() => setShowFrame(null)}\n                      className=\"py-1 px-2 -m-2 hover:bg-gray-500/10 rounded\"\n                    >\n                      <svg\n                        xmlns=\"http://www.w3.org/2000/svg\"\n                        fill=\"none\"\n                        viewBox=\"0 0 24 24\"\n                        strokeWidth={1.5}\n                        stroke=\"currentColor\"\n                        className=\"size-6\"\n                      >\n                        <title>Close</title>\n                        <path\n                          strokeLinecap=\"round\"\n                          strokeLinejoin=\"round\"\n                          d=\"M6 18 18 6M6 6l12 12\"\n                        />\n                      </svg>\n                    </button>\n                  </div>\n                  <div className=\"divide-y divide-gray-200\">\n                    {Object.entries(frame.local_values).map(([key, html]) => (\n                      <div key={key} className=\"flex\">\n                        <div className=\"w-48 shrink-0 bg-gray-50 p-4 font-mono text-sm text-gray-600 border-r\">\n                          {key}\n                        </div>\n                        <div\n                          className=\"flex-1 p-4 overflow-x-auto font-mono text-sm bg-gray-700\"\n                          // biome-ignore lint/security/noDangerouslySetInnerHtml: Required for server HTML rendering\n                          dangerouslySetInnerHTML={{ __html: html }}\n                        />\n                      </div>\n                    ))}\n                  </div>\n                </div>\n              )}\n            </div>\n          ))}\n        </div>\n      </div>\n    </>\n  );\n};\n\nexport default Page;\n","import React from 'react';\nimport mountLiveReload from '/home/runner/work/mountaineer-exceptions/mountaineer/mountaineer/static/live_reload.ts';\n\nimport Layout0 from '/home/runner/work/mountaineer-exceptions/mountaineer-exceptions/mountaineer_exceptions/views/core/layout.tsx';\nimport Layout1 from '/home/runner/work/mountaineer-exceptions/mountaineer-exceptions/mountaineer_exceptions/views/core/exception/page.tsx';\n\nconst Entrypoint = () => {\n    mountLiveReload({SSR_RENDERING: process.env.SSR_RENDERING, NODE_ENV: process.env.NODE_ENV, LIVE_RELOAD_PORT: process.env.LIVE_RELOAD_PORT});\n    return (\n        <Layout0>\n                <Layout1>\n                </Layout1>\n        </Layout0>\n    );\n};\n\nimport { hydrateRoot } from 'react-dom/client';\nconst container = document.getElementById('root');\nhydrateRoot(container, <Entrypoint />);\n"],"mappings":"kJAwCa,EAAqB,AAChCA,GACuB,CAInB,MAAU,KAQd,OAJI,aAAiB,KACZ,EAAM,aAAa,CAGrB,OAAO,EAAM,AACrB,EAEY,EAAmB,AAC9BC,GAC0B,CAI1B,IAAM,EAAe,IAAI,EAEzB,IAAK,GAAM,CAAC,EAAK,EAAM,EAAI,QAAO,QAAQ,EAAO,CAAE,CACjD,GAAI,GAAU,KACZ,SAGF,GAAI,MAAM,QAAQ,EAAM,CAEtB,EAAM,QAAQ,AAAC,GAAS,CACtB,IAAM,EAAW,EAAmB,EAAK,CACzC,AAAI,QAAA,IACF,EAAa,OAAO,EAAK,EAAS,AAErC,EAAC,KACG,CAEL,IAAM,EAAW,EAAmB,EAAM,CAC1C,AAAI,QAAA,IACF,EAAa,OAAO,EAAK,EAAS,AAErC,CACF,CAED,OAAO,CACR,EAkNY,EAAY,AAACC,GAA0B,CAElD,IAAM,EAAM,IAAI,EAAU,EAAO,QAGjC,IAAK,GAAM,CAAC,EAAK,EAAM,EAAI,QAAO,QAAQ,EAAO,eAAe,CAAE,CAChE,IAAM,EAAW,EAAmB,EAAM,CAC1C,GAAI,QAAA,GACF,KAAM,CAAI,OAAO,kCAAkC,EAAI,EAAA,CAEzD,EAAI,SAAW,mBAAmB,EAAI,SAAS,CAAC,SAC7C,GAAG,EAAI,GACR,EACD,AACF,CAGD,GAAI,EAAO,gBAAiB,CAC1B,IAAM,EAAe,EAAiB,EAAO,gBAAgB,CAC7D,EAAI,OAAS,EAAa,UAAU,AACrC,CAED,MAAO,oBAAmB,EAAI,UAAU,CAAC,AAC1C,MAEY,EAAN,KAAgB,CACrB,UAA4B,GAC5B,MAAwB,GACxB,UAA4B,GAC5B,QAA0B,GAE1B,YAAYC,EAAaC,EAAe,CAEtC,GAAI,EAAI,MAAM,kBAAkB,CAAE,CAEhC,GADM,CAAC,EAAU,EAAK,CAAG,EAAI,MAAM,MAAM,CACnC,CAAC,EAAM,GAAG,EAAU,CAAG,EAAK,MAAM,IAAI,CAG5C,AAFA,KAAK,UAAY,EACjB,KAAK,MAAQ,EACb,KAAK,UAAY,IAAM,EAAU,KAAK,IAAI,CAC1C,MACD,CAGD,GAAM,CAAC,EAAU,EAAO,CAAG,EAAI,MAAM,IAAI,CAGzC,GAAI,IAAS,EAAS,WAAW,IAAI,CAAE,CACrC,IAAM,EAAU,EAAK,SAAS,IAAI,CAAG,EAAO,EAAO,IACnD,KAAK,UAAY,KAAK,cAAc,EAAU,EAAS,AACxD,MACC,KAAK,UAAY,KAAK,cAAc,EAAS,CAG/C,KAAK,QAAU,GAAU,GAAG,EAAO,EAAI,EACxC,CAED,cAAsBC,EAAsB,CAE1C,AAAK,EAAK,WAAW,IAAI,GACvB,EAAO,IAAM,GAKf,IADM,EAAW,EAAK,MAAM,IAAI,CAC1BC,EAAuB,CAAE,EAE/B,IAAK,IAAM,KAAW,EAAU,CAC9B,IAAK,GAAW,IAAY,IAAK,SACjC,AAAI,IAAY,KACd,EAAW,KAAK,CAEhB,EAAW,KAAK,EAAQ,AAE3B,CAED,MAAO,IAAM,EAAW,KAAK,IAAI,AAClC,CAED,IAAI,UAAmB,CACrB,OAAO,KAAK,SACb,CAED,IAAI,SAASC,EAAe,CAC1B,KAAK,UAAY,KAAK,cAAc,EAAM,AAC3C,CAED,IAAI,QAAiB,CACnB,OAAO,KAAK,OACb,CAED,IAAI,OAAOA,EAAe,CACxB,KAAK,QAAU,EAAS,EAAM,WAAW,IAAI,CAAG,GAAS,GAAG,EAAM,EAAK,EACxE,CAED,UAAmB,CAIjB,OAHI,KAAK,WAAa,KAAK,OACjB,EAAE,KAAK,UAAU,KAAK,KAAK,MAAM,EAAE,KAAK,UAAU,EAAE,KAAK,QAAQ,GAEnE,EAAE,KAAK,UAAU,EAAE,KAAK,QAAQ,CACzC,CACF,EAEY,EAAN,KAA4B,CACjC,OAEA,YAAYC,EAAmD,CAC7D,QAAK,OAAS,IAAI,MAEb,EAEL,UAAW,GAAS,SAAU,CAE5B,IAAM,EAAQ,EAAK,WAAW,IAAI,CAAG,EAAK,MAAM,EAAE,CAAG,EACrD,IAAK,IAAM,IAAQ,GAAM,MAAM,IAAI,CAAE,CACnC,IAAK,EAAM,SACX,GAAM,CAAC,EAAK,EAAM,CAAG,EAAK,MAAM,IAAI,CAAC,IAAI,mBAAmB,CAC5D,KAAK,OAAO,EAAK,GAAS,GAAG,AAC9B,CACF,MAEC,IAAK,GAAM,CAAC,EAAK,EAAM,EAAI,QAAO,QAAQ,EAAK,CAC7C,GAAI,MAAM,QAAQ,EAAM,CACtB,IAAK,IAAM,KAAK,EACd,KAAK,OAAO,EAAK,EAAE,MAGrB,KAAK,OAAO,EAAK,EAAM,AAI9B,CAED,OAAOC,EAAaF,EAAqB,CACvC,IAAM,EAAS,KAAK,OAAO,IAAI,EAAI,EAAI,CAAE,EAEzC,AADA,EAAO,KAAK,OAAO,EAAM,CAAC,CAC1B,KAAK,OAAO,IAAI,EAAK,EAAO,AAC7B,CAED,UAAmB,CACjB,IAAMG,EAAkB,CAAE,EAC1B,IAAK,GAAM,CAAC,EAAK,EAAO,GAAI,KAAK,OAC/B,IAAK,IAAM,KAAS,EAClB,EAAM,MAAM,EAAE,mBAAmB,EAAI,CAAC,GAAG,mBAAmB,EAAM,CAAC,EAAE,CAGzE,MAAO,GAAM,KAAK,IAAI,AACvB,CACF,EEvbD,MDEa,EAAU,CAAC,CACtB,YACA,QAID,GAAK,CAOJ,IANM,EAAA,cAEAC,EAAuC,CAC3C,YACA,OACD,EACKC,EAAsC,CAE3C,EAED,MAAO,GAAU,CACf,OAAQ,EACR,kBACA,gBACD,EAAC,AACH,ECxBK,EAAgB,CACpB,oBAAqBC,CACtB,QAEc,EEPf,MDiBa,EAAY,IAAoB,CAG3C,GAFM,CAAC,EAAa,EAAe,CAAG,CAAA,EAAA,EAAA,UAAS,YAAY,oBAA0C,CAE/F,EAAqB,AAACC,GAAqC,CAC/D,EAAe,AAAC,IAAW,CACzB,GAAG,EACH,GAAG,CACJ,GAAE,AACJ,EAED,MAAO,CACP,GAAG,gBACcC,CAClB,CACA,EC/BK,EAAO,IAAM,CAGjB,IAFM,EAAc,GAAW,CACzB,CAAC,EAAW,EAAa,CAAG,CAAA,EAAA,EAAA,UAAwB,KAAK,CACzD,EAAY,IAAI,OAAO,aAAa,CAE1C,MACE,CAAA,EAAA,EAAA,MAAA,EAAA,SAAA,CAAA,SAAA,CACE,CAAA,EAAA,EAAA,KAAC,QAAA,CAAA,SAAO,EAAY,gBAAA,EAAyB,CAC7C,CAAA,EAAA,EAAA,KAAC,QAAA,CAAA,SAAA;;;;WAIW,CACZ,CAAA,EAAA,EAAA,MAAC,MAAA,CAAI,UAAU,8CACb,CAAA,EAAA,EAAA,MAAC,MAAA,CAAI,UAAU,sBACb,CAAA,EAAA,EAAA,MAAC,MAAA,CAAI,UAAU,4CAAkC,cACnC,EACZ,CAAA,EAAA,EAAA,KAAC,KAAA,CAAA,EAAK,gCAEF,CACN,CAAA,EAAA,EAAA,KAAC,KAAA,CAAG,UAAU,6EACX,EAAY,WACV,GACD,CACN,CAAA,EAAA,EAAA,MAAC,MAAA,CAAI,UAAU,sBACb,CAAA,EAAA,EAAA,MAAC,MAAA,CAAI,UAAU,uFACb,CAAA,EAAA,EAAA,MAAC,OAAA,CAAA,SAAA,CAAM,EAAY,iBAAiB,SAAS,GAAA,CAAA,EAAQ,CACrD,CAAA,EAAA,EAAA,KAAC,OAAA,CAAA,SAAM,EAAY,iBAAiB,SAAA,EAAiB,GACjD,CAEL,EAAY,iBAAiB,OAAO,IAAI,CAAC,EAAO,IAC/C,CAAA,EAAA,EAAA,MAAC,MAAA,CAAA,SAAA,CACC,CAAA,EAAA,EAAA,MAAC,MAAA,CAAI,UAAU,uDAEb,CAAA,EAAA,EAAA,MAAC,MAAA,CAAI,UAAU,6EACb,CAAA,EAAA,EAAA,MAAC,MAAA,CAAI,UAAU,4CACZ,EAAM,UAAU,IAAE,EAAM,cACrB,CACN,CAAA,EAAA,EAAA,KAAC,SAAA,CACD,KAAK,SACH,QAAS,IAAM,CACb,AAAI,IAAc,EAAM,GAGtB,EAAa,KAAK,CAFlB,EAAa,EAAM,GAAG,AAIzB,EACD,UAAU,gGAET,EAAM,eACA,GACL,CAGN,CAAA,EAAA,EAAA,MAAC,MAAA,CAAI,UAAU,iBAEb,CAAA,EAAA,EAAA,KAAC,MAAA,CAAI,UAAU,gGACZ,MAAM,KACL,CACE,OAAQ,EAAM,gBAAkB,EAAM,iBACvC,EACD,CAAC,EAAG,IACF,CAAA,EAAA,EAAA,KAAC,MAAA,CAGC,WAAY,YACV,EAAM,kBAAoB,IAAM,EAAM,YAClC,mDACA,GACL,WAEA,EAAM,kBAAoB,GAPtB,EAQD,CAET,EACG,CAGN,CAAA,EAAA,EAAA,KAAC,MAAA,CACC,UAAU,sEAEV,wBAAyB,CAAE,OAAQ,EAAM,YAAc,GACvD,GACE,GACF,CAGL,IAAc,EAAM,IACnB,CAAA,EAAA,EAAA,MAAC,MAAA,CAAI,UAAU,mFACb,CAAA,EAAA,EAAA,MAAC,MAAA,CAAI,UAAU,iGACb,CAAA,EAAA,EAAA,KAAC,MAAA,CAAI,UAAU,gBAAO,mBAAqB,CAC3C,CAAA,EAAA,EAAA,KAAC,SAAA,CACC,KAAK,SACL,QAAS,IAAM,EAAa,KAAK,CACjC,UAAU,uDAEV,CAAA,EAAA,EAAA,MAAC,MAAA,CACC,MAAM,6BACN,KAAK,OACL,QAAQ,YACR,YAAa,IACb,OAAO,eACP,UAAU,mBAEV,CAAA,EAAA,EAAA,KAAC,QAAA,CAAA,SAAM,OAAA,EAAa,CACpB,CAAA,EAAA,EAAA,KAAC,OAAA,CACC,cAAc,QACd,eAAe,QACf,EAAE,wBACF,GACE,EACC,GACL,CACN,CAAA,EAAA,EAAA,KAAC,MAAA,CAAI,UAAU,oCACZ,OAAO,QAAQ,EAAM,aAAa,CAAC,IAAI,CAAC,CAAC,EAAK,EAAK,GAClD,CAAA,EAAA,EAAA,MAAC,MAAA,CAAc,UAAU,iBACvB,CAAA,EAAA,EAAA,KAAC,MAAA,CAAI,UAAU,iFACZ,GACG,CACN,CAAA,EAAA,EAAA,KAAC,MAAA,CACC,UAAU,2DAEV,wBAAyB,CAAE,OAAQ,CAAM,GACzC,GARM,EASJ,CACN,EACE,GACF,CAAA,EAhGA,EAAM,GAkGV,CACN,GACE,GACF,GACL,AAEN,QAEc,EC3Hf,MAXM,EAAa,KACf,EAAgB,CAAC,eAAA,EAA0C,SAAA,aAAgC,iBAAA,CAA+C,EAAC,CAEvI,CAAA,EAAA,EAAA,KAACC,EAAAA,CAAAA,SACO,CAAA,EAAA,EAAA,KAACC,EAAAA,CAAAA,EACS,EACR,EAKZ,EAAY,SAAS,eAAe,OAAO,CACjD,CAAA,EAAA,EAAA,aAAY,EAAW,CAAA,EAAA,EAAA,KAAC,EAAA,CAAA,EAAa,CAAC"}